//
//  BackendModel.h
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/1/6.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface BackendModel : NSObject

@end


@interface ServerResponse : NSObject

@property (nonatomic, assign) int code;
@property (nonatomic, copy) NSString *message;
@property (nonatomic, copy) NSString *requestID;
@end


@interface GetTokenRequest : NSObject

@property (nonatomic, assign) long appID;
@property (nonatomic, copy) NSString *userID;

- (void)getTokenRequest:(NSString *)userID appID:(long)appID;
- (NSDictionary *)toRequestDictionary;
@end


@interface DescribeGameLaunchCodeRequest : NSObject

@property (nonatomic, assign) long appID;
@property (nonatomic, copy) NSString *roomID;
@property (nonatomic, copy) NSString *miniGameId;
@property (nonatomic, copy) NSString *userID;
@property (nonatomic, copy) NSString *nickName;
@property (nonatomic, copy) NSString *avatar;
@property (nonatomic, assign) int sex;


- (void)describeGameLaunchCode:(long)appID roomID:(NSString *)roomID miniGameId:(NSString *)miniGameId userID:(NSString *)userID nickName:(NSString *)nickName avatar:(NSString *)avatar sex:(int)sex;
- (NSDictionary *)toRequestDictionary;
@end

@interface DescribeGameLaunchCodeData : NSObject

 
@property (nonatomic, copy) NSString *gameLaunchCode;

@end
 
@interface DescribeGameLaunchCodeResponse : ServerResponse

@property (nonatomic, strong) DescribeGameLaunchCodeData *Data;
@end

 
NS_ASSUME_NONNULL_END
