//
//  BackendModel.m
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/1/6.
//

#import "BackendModel.h"
#import <NSObject+YYModel.h>

@implementation BackendModel

@end

@implementation ServerResponse

+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
    return @{@"code": @"Code", @"message": @"Message", @"requestID": @"RequestId"};
}
@end


@implementation GetTokenRequest

- (void)getTokenRequest:(NSString *)userID appID:(long)appID {
    self.appID = appID;
    self.userID = userID;
}

- (NSDictionary *)toRequestDictionary {
    return @{
        @"app_id": @(self.appID),
        @"user_id": self.userID,
    };
}
@end


@implementation DescribeGameLaunchCodeRequest

- (void)describeGameLaunchCode:(long)appID roomID:(NSString *)roomID miniGameId:(NSString *)miniGameId userID:(NSString *)userID nickName:(NSString *)nickName avatar:(NSString *)avatar sex:(int)sex {
    self.appID = appID;
    self.roomID = roomID;
    self.miniGameId = miniGameId;
    self.userID = userID;
    self.nickName = nickName;
    self.avatar = avatar;
    self.sex = sex;
}
- (NSDictionary *)toRequestDictionary {
    return @{
        @"RoomId" : self.roomID,
        @"MiniGameId" : self.miniGameId,
        @"AnchorId" : self.userID,
        @"Nickname" : self.nickName,
        @"Avatar" : self.avatar,
        @"Sex" : @(self.sex),
        @"AppId": @(self.appID),
    };
}

@end

@implementation DescribeGameLaunchCodeData
 
+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
    return @{@"gameLaunchCode": @"GameLaunchCode"};
}
@end

@implementation DescribeGameLaunchCodeResponse
 
@end
