//
//  ZGSDKVersionView.m
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2024/5/23.
//

#import "ZGSDKVersionView.h"

@interface ZGSDKVersionView ()

@property (nonatomic, strong) UILabel *versionLabel;

@end

@implementation ZGSDKVersionView

- (instancetype)initWithFrame:(CGRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        [self setupUI];
    }
    
    return self;
}

- (void)setupUI {
    self.layer.cornerRadius = 10;
    self.layer.masksToBounds = YES;
    self.backgroundColor = [UIColor colorWithHexString:@"#574979"];
    
    [self addSubview:self.versionLabel];
    [self.versionLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self);
        make.right.equalTo(self).offset(-32);
    }];
}

- (void)updateVersionLabel:(NSString *)text {
    self.versionLabel.text = text;
}

- (UILabel *)versionLabel {
    if(!_versionLabel) {
        _versionLabel = [UILabel new];
        _versionLabel.text = TLLocalizedString(language_system);
        _versionLabel.textColor = [UIColor colorWithHexString:@"A8A4AE"];
        _versionLabel.font = [UIFont systemFontOfSize:14];
        _versionLabel.textAlignment = NSTextAlignmentLeft;
        [_versionLabel sizeToFit];
    }
    return _versionLabel;
}

@end
