//
//  TLTestLoginView.m
//  ZegoRoomkitDemo
//
//  Created by KaelDing on 2020/7/15.
//  Copyright © 2020 zego. All rights reserved.
//

#import "MineGameMainView.h"
#import "GameTableViewCell.h"
#import "DemoGameInfo.h"

@interface MineGameMainView () <UITableViewDelegate, UITableViewDataSource>

@property (nonatomic, strong) UILabel *tipLabel;
@property (nonatomic, strong) UIView *businessView;
@property (nonatomic, strong) UILabel *businessTitleLabel;
@property (nonatomic, strong) UILabel *businessNotesLabel;
@property (nonatomic, strong) UIView *pointsView;
@property (nonatomic, strong) UILabel *pointsLabel;
@property (nonatomic, strong) UIButton *resetButton;

@property (nonatomic, strong) UIView *gameView;
@property (nonatomic, strong) UILabel *gameTitleLabel;
@property (nonatomic, strong) UILabel *gameNotesLabel;
@property (nonatomic, strong) UILabel *gamePointsTitleLabel;
@property (nonatomic, strong) UILabel *gamePointsAmountLabel;
@property (nonatomic, strong) UIButton *exchangeButton;
@property (nonatomic, strong) UIButton *withdrawButton;

@property (nonatomic, assign) long initPoints;
@end

@implementation MineGameMainView
 
- (instancetype)initWithFrame:(CGRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        [self setupUI];
        [self initData];
    }
    return self;
}

- (void)setupUI {
    [self addSubview:self.tipLabel];
    [self addSubview:self.businessView];
    [self.businessView addSubview:self.businessTitleLabel];
    [self.businessView addSubview:self.businessNotesLabel];
    [self.businessView addSubview:self.pointsView];
    [self.pointsView addSubview:self.pointsLabel];
    [self.pointsView addSubview:self.pointsAmountLabel];
    [self.pointsView addSubview:self.resetButton];
    [self addSubview:self.gameView];
    [self.gameView addSubview:self.gameTitleLabel];
    [self.gameView addSubview:self.gameNotesLabel];
//    [self.gameView addSubview:self.gamePointsTitleLabel];
//    [self.gameView addSubview:self.gamePointsAmountLabel];
//    [self.gameView addSubview:self.exchangeButton];
//    [self.gameView addSubview:self.withdrawButton];
    [self.gameView addSubview:self.gameTableView];
    
    
    [self.tipLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self);
        make.left.equalTo(self.mas_left).offset(16);
        make.width.mas_equalTo(kScreenWidth - 32);
        make.height.mas_equalTo(51);
    }];
    
    [self.businessView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.tipLabel.mas_bottom).offset(14);
        make.left.width.equalTo(self.tipLabel);
    }];
    
    [self.businessTitleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.mas_centerX);
        make.top.mas_equalTo(18);
        make.height.mas_equalTo(22);
    }];
    
    [self.businessNotesLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.businessView).offset(20);
        make.right.equalTo(self.businessView).offset(-20);
        make.top.equalTo(self.businessTitleLabel.mas_bottom).offset(10);
    }];
    
    [self.pointsView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.businessView.mas_centerX);
        make.top.equalTo(self.businessNotesLabel.mas_bottom).offset(20);
        make.height.mas_equalTo(28);
        make.left.right.equalTo(self.businessView);
        make.bottom.equalTo(self.businessView).offset(-18);
    }];
    
    [self.pointsLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.pointsView).offset(20);
        make.top.bottom.equalTo(self.pointsView);
    }];
    
    [self.pointsAmountLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.pointsLabel.mas_right).offset(2);
        make.centerY.equalTo(self.pointsLabel.mas_centerY);
    }];
    
    [self.resetButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.pointsView.mas_right).offset(-20);
        make.centerY.equalTo(self.pointsAmountLabel.mas_centerY);
        make.width.mas_equalTo(78);
        make.height.mas_equalTo(32);
      
    }];
    
    [self.gameView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.businessView.mas_bottom).offset(16);
        make.left.width.equalTo(self.businessView);
        make.bottom.equalTo(self);
    }];
    
    [self.gameTitleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.gameView.mas_centerX);
        make.top.equalTo(self.gameView).offset(18);
        make.height.mas_equalTo(22);
    }];
    
    [self.gameNotesLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.gameView).offset(20);
        make.right.equalTo(self.gameView).offset(-20);
        make.top.equalTo(self.gameTitleLabel.mas_bottom).offset(10);
    }];
    
//    [self.gamePointsTitleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.left.equalTo(self.gameView).offset(20);
//        make.top.equalTo(self.gameNotesLabel.mas_bottom).offset(21);
//        make.bottom.equalTo(self.gameView).offset(-33);;
//    }];
//
//    [self.gamePointsAmountLabel mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.centerY.equalTo(self.gamePointsTitleLabel);
//        make.left.equalTo(self.gamePointsTitleLabel.mas_right).offset(2);
//    }];
//
//    [self.exchangeButton mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.right.equalTo(self.gameView.mas_right).offset(-20);
//        make.centerY.equalTo(self.gamePointsAmountLabel.mas_centerY);
//        make.width.mas_equalTo(74);
//        make.height.mas_equalTo(28);
//    }];
//
//    [self.withdrawButton mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.right.equalTo(self.exchangeButton.mas_left).offset(-6);
//        make.centerY.equalTo(self.exchangeButton.mas_centerY);
//        make.width.mas_equalTo(74);
//        make.height.mas_equalTo(28);
//    }];
    
    [self.gameTableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.gameView);
        make.top.equalTo(self.gameNotesLabel.mas_bottom).offset(20);
        make.bottom.equalTo(self.gameView.mas_bottom);
    }];
    
}

- (void)initData {
    self.initPoints = self.viewModel.allGameList.count * EXCHANGE_POINT_NUMBER;
    self.gamePointsAmountLabel.text = [NSString stringWithFormat:@"%lu", self.initPoints];
}

- (void)configureData {
//    self.gamePointsAmountLabel.text = self.viewModel.gam;
    self.initPoints = self.viewModel.allGameList.count * EXCHANGE_POINT_NUMBER;
    self.gamePointsAmountLabel.text = [NSString stringWithFormat:@"%lu", self.initPoints];
}

- (void)layoutSubviews {
    
}

#pragma mark - TableViewDelegate & DataSource

- (NSInteger)tableView:(nonnull UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.viewModel.allGameList.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    GameTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"GameTableViewCell" forIndexPath:indexPath];
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    cell.userInteractionEnabled = YES;
    cell.backgroundColor = [UIColor clearColor];
    
    [cell setMiniGameInfo:self.viewModel.allGameList[indexPath.row]];
    __weak typeof(GameTableViewCell) *weakCell = cell;
    cell.exchangeBlock = ^(DemoGameInfo * info) {
        if (self.viewModel.businessPoint >= EXCHANGE_POINT_NUMBER) {
            info.gamePoint += EXCHANGE_POINT_NUMBER;
            self.viewModel.businessPoint = self.viewModel.businessPoint - EXCHANGE_POINT_NUMBER;
            self.pointsAmountLabel.text = [NSString stringWithFormat:@"%d", (int)self.viewModel.businessPoint];
            weakCell.gamePointsAmountLabel.text = [NSString stringWithFormat:@"%d", (int)info.gamePoint];
        } else {
            [MBProgressHUD showSuccess:TLLocalizedString(business_point_is_not_enough) withFinishBlock:nil];
        }
    };
    cell.preloadBlock = ^(DemoGameInfo *info, UIButton * btn) {
        [ZegoMiniGameEngine.sharedEngine preLoadGame:info.gameInfo.gameID callBack:^(NSInteger errorCode, int progress) {
            info.progress = progress;
            NSString *title = [NSString stringWithFormat:@"preload:%d", progress];
            if (errorCode == 0 && progress == 100) {
                NSLog(@"preLoadGame success");
                [btn setTitle:title forState:UIControlStateNormal];
            } else if (errorCode == 0 && progress != 100) {
                NSLog(@"preLoadGame progress:%d", progress);
                [btn setTitle:title forState:UIControlStateNormal];
            } else {
                NSLog(@"preLoadGame fail %ld", errorCode);
                [MBProgressHUD showError:[NSString stringWithFormat:@"preload fail:%d", (int)errorCode] withFinishBlock:nil];
            }
        }];
    };
    
    cell.cancelBlock = ^(DemoGameInfo * info, UIButton * btn) {
        [ZegoMiniGameEngine.sharedEngine unPreloadGame:info.gameInfo.gameID];
    };
    
    cell.longTapBlock = ^(DemoGameInfo * info) {
        [ZegoMiniGameEngine.sharedEngine clearGameResources:info.gameInfo.gameID];
        [MBProgressHUD showError:@"success" withFinishBlock:nil];
    };
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 78;
}

#pragma mark - action

- (void)onResetButtonActionButtonClick:(UIButton *)sender {
    self.viewModel.businessPoint = BUSINESS_POINT_RESET;
    self.pointsAmountLabel.text = [NSString stringWithFormat:@"%d", (int)self.viewModel.businessPoint];
}

- (void)onExchangeButtonActionButtonClick:(UIButton *)sender {
    if (self.viewModel.businessPoint >= EXCHANGE_POINT_NUMBER) {
        self.initPoints += EXCHANGE_POINT_NUMBER;
        self.viewModel.businessPoint = self.viewModel.businessPoint - EXCHANGE_POINT_NUMBER;
        self.pointsAmountLabel.text = [NSString stringWithFormat:@"%d", (int)self.viewModel.businessPoint];
        self.gamePointsAmountLabel.text = [NSString stringWithFormat:@"%d", (int)self.initPoints];
    } else {
        [MBProgressHUD showSuccess:TLLocalizedString(business_point_is_not_enough) withFinishBlock:nil];
    }
}

- (void)onWithdrawButtonActionButtonClick:(UIButton *)sender {
    
}

 
#pragma mark - getter
 
- (UILabel *)tipLabel {
    if(!_tipLabel) {
        _tipLabel = [[UILabel alloc] init];
        _tipLabel.text = TLLocalizedString(mall_note1);
        _tipLabel.numberOfLines = 0;
        _tipLabel.textColor = [UIColor colorWithRed:255/255.0 green:91/255.0 blue:91/255.0 alpha:1/1.0];
        _tipLabel.font = [UIFont systemFontOfSize:12];
        _tipLabel.textAlignment = NSTextAlignmentLeft;
        [_tipLabel sizeToFit];
    }
    return _tipLabel;
}

- (UIView *)businessView {
    if (!_businessView) {
        _businessView = [UIView new];
        _businessView.layer.cornerRadius = 20;
        _businessView.layer.masksToBounds = YES;
        _businessView.backgroundColor = [UIColor colorWithHexString:@"#574979"];
    }
    return _businessView;
}

- (UILabel *)businessTitleLabel {
    if (!_businessTitleLabel) {
        _businessTitleLabel = [[UILabel alloc] init];
        _businessTitleLabel.text = TLLocalizedString(business_point);
        _businessTitleLabel.textColor = [UIColor whiteColor];
        _businessTitleLabel.font = [UIFont systemFontOfSize:16];
        _businessTitleLabel.textAlignment = NSTextAlignmentCenter;
        [_businessTitleLabel sizeToFit];
    }
    return _businessTitleLabel;
}

- (UILabel *)businessNotesLabel {
    if (!_businessNotesLabel) {
        _businessNotesLabel = [[UILabel alloc] init];
        _businessNotesLabel.numberOfLines = 0;
        _businessNotesLabel.text = TLLocalizedString(business_point_note1);
        _businessNotesLabel.textColor = [UIColor colorWithRGB:0xffffffff alpha:0.7];
        _businessNotesLabel.font = [UIFont systemFontOfSize:12];
        _businessNotesLabel.textAlignment = NSTextAlignmentLeft;
        [_businessNotesLabel sizeToFit];
    }
    return _businessNotesLabel;
}

- (UIView *)pointsView {
    if (!_pointsView) {
        _pointsView = [UIView new];
    }
    return _pointsView;
}

- (UILabel *)pointsLabel {
    if (!_pointsLabel) {
        _pointsLabel = [[UILabel alloc] init];
        _pointsLabel.text = TLLocalizedString(business_point_count);
        _pointsLabel.textColor = [UIColor colorWithRGB:0xffffffff alpha:0.7];
        _pointsLabel.font = BOLD_FONT(12);;
        _pointsLabel.textAlignment = NSTextAlignmentCenter;
        [_pointsLabel sizeToFit];
    }
    return _pointsLabel;
}

- (UILabel *)pointsAmountLabel {
    if (!_pointsAmountLabel) {
        _pointsAmountLabel = [[UILabel alloc] init];
        _pointsAmountLabel.text = @"100000";
        _pointsAmountLabel.textColor = [UIColor whiteColor];
        _pointsAmountLabel.font = BOLD_FONT(15);
        _pointsAmountLabel.textAlignment = NSTextAlignmentCenter;
        [_pointsAmountLabel sizeToFit];
    }
    return _pointsAmountLabel;
}

- (UIButton *)resetButton {
    if (!_resetButton) {
        _resetButton = [UIButton actionButtonWithTitle:TLLocalizedString(reset)];
        _resetButton.titleLabel.font = [UIFont systemFontOfSize:13];
        _resetButton.layer.cornerRadius = 16;
        _resetButton.layer.masksToBounds = YES;
        [_resetButton addTarget:self action:@selector(onResetButtonActionButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _resetButton;
}

- (UIView *)gameView {
    if (!_gameView) {
        _gameView = [UIView new];
        _gameView.layer.cornerRadius = 20;
        _gameView.layer.masksToBounds = YES;
        _gameView.backgroundColor = [UIColor colorWithHexString:@"#574979"];
    }
    return _gameView;
}

- (UILabel *)gameTitleLabel {
    if (!_gameTitleLabel) {
        _gameTitleLabel = [[UILabel alloc] init];
        _gameTitleLabel.text = TLLocalizedString(game_point);
        _gameTitleLabel.textColor = [UIColor whiteColor];
        _gameTitleLabel.font = [UIFont systemFontOfSize:16];
        _gameTitleLabel.textAlignment = NSTextAlignmentCenter;
        [_gameTitleLabel sizeToFit];
    }
    return _gameTitleLabel;
}

- (UILabel *)gameNotesLabel {
    if (!_gameNotesLabel) {
        _gameNotesLabel = [[UILabel alloc] init];
        _gameNotesLabel.numberOfLines = 0;
        _gameNotesLabel.text = TLLocalizedString(game_point_note1);
        _gameNotesLabel.textColor = [UIColor colorWithRGB:0xffffffff alpha:0.7];
        _gameNotesLabel.font = [UIFont systemFontOfSize:12];
        _gameNotesLabel.textAlignment = NSTextAlignmentLeft;
        [_gameNotesLabel sizeToFit];
    }
    return _gameNotesLabel;
}

- (UILabel *)gamePointsTitleLabel {
    if (!_gamePointsTitleLabel) {
        _gamePointsTitleLabel = [[UILabel alloc] init];
        _gamePointsTitleLabel.text = [NSString stringWithFormat:@"%@：", TLLocalizedString(game_point)];
        _gamePointsTitleLabel.textColor = [UIColor colorWithRGB:0xffffffff alpha:0.7];
        _gamePointsTitleLabel.font = BOLD_FONT(12);
        _gamePointsTitleLabel.textAlignment = NSTextAlignmentLeft;
        [_gamePointsTitleLabel sizeToFit];
    }
    return _gamePointsTitleLabel;
}

- (UILabel *)gamePointsAmountLabel {
    if (!_gamePointsAmountLabel) {
        _gamePointsAmountLabel = [[UILabel alloc] init];
        _gamePointsAmountLabel.text = @"10000";
        _gamePointsAmountLabel.textColor = [UIColor whiteColor];
        _gamePointsAmountLabel.font = BOLD_FONT(15);
        _gamePointsAmountLabel.textAlignment = NSTextAlignmentCenter;
        [_gamePointsAmountLabel sizeToFit];
    }
    return _gamePointsAmountLabel;
}

- (UITableView *)gameTableView {
    if (!_gameTableView) {
        _gameTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, 0, 0)];
        _gameTableView.delegate = self;
        _gameTableView.dataSource = self;
        [_gameTableView registerClass:[GameTableViewCell class] forCellReuseIdentifier:@"GameTableViewCell"];
        _gameTableView.backgroundColor = [UIColor clearColor];
    }
    return _gameTableView;
}

- (UIButton *)exchangeButton {
    if (!_exchangeButton) {
        _exchangeButton = [UIButton actionButtonWithTitle:TLLocalizedString(deposit)];
        _exchangeButton.titleLabel.font = [UIFont systemFontOfSize:13];
        _exchangeButton.layer.cornerRadius = 14;
        _exchangeButton.layer.masksToBounds = YES;
        [_exchangeButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [_exchangeButton addTarget:self action:@selector(onExchangeButtonActionButtonClick:) forControlEvents:UIControlEventTouchUpInside];
        _exchangeButton.userInteractionEnabled = YES;
    }
    return _exchangeButton;
}

- (UIButton *)withdrawButton {
    if (!_withdrawButton) {
        _withdrawButton = [UIButton actionButtonWithTitle:TLLocalizedString(withdraw)];
        _withdrawButton.titleLabel.font = [UIFont systemFontOfSize:13];
        _withdrawButton.layer.cornerRadius = 14;
        _withdrawButton.layer.masksToBounds = YES;
        _withdrawButton.backgroundColor = [UIColor colorWithRGB:0xffffffff alpha:0.1];
        [_withdrawButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [_withdrawButton addTarget:self action:@selector(onWithdrawButtonActionButtonClick:) forControlEvents:UIControlEventTouchUpInside];
        _withdrawButton.userInteractionEnabled = YES;
    }
    return _withdrawButton;
}
@end
